<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: tools/telegram/telegram.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: tools/telegram/telegram.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
* for now only allows sending messages from a telegram bot
*
* @requires tool
* @requires logic
*
* @module telegram
*/

const tool = require('../tool.js')
const { DesignError } = require('../../errors')
var schema = require('./schema.json')

const request = require('request')

class Telegram extends tool.Tool {
  constructor() {
    super(schema)
  }
  
  setup(config) {
    return new Promise((resolve, reject) => {
      //this.update(config.settings)
      super.setup(config)
      .then(function(result) {
        this.bot.add = function(data) {
          this.bot.items[data.name] = new Bot(data, this.app, this.db.bot.document({_id:this.db.bot.makeID(data._id)}))
        }.bind(this)
        return this.bot.collectItems()
      }.bind(this))
      .then(function(result) {
        resolve(schema)
      })
      .catch(function(error){
        log.error(this.name, error)
        reject(error)
      }.bind(this))
    })
  }
  
  cue(data, session) {
    return new Promise((resolve, reject) =>  {
      for(let item in data.telegram) {
        switch(item) {
          case "send":
            this.send(data.telegram.send, session)
            .then(result => {
              return resolve(undefined)
            })
            .catch(error => {
              return reject(error)
            })
            break
        }
      }
    })
  }
  
  /**
  * send text message to channel from bot
  * @todo allow sending to multiple channels when variables.get returns more than one item
  */
  send(properties, session) {
    return new Promise((resolve, reject) => {
      var agent = {}
      var channel = undefined
      if(properties.hasOwnProperty("bot")) {
        if(this.bot.items.hasOwnProperty(properties.bot)) {
          agent = this.bot.items[properties.bot]
        } else {
          throw new DesignError("Not an existing bot: " + properties.bot)
        }
      } else {
        throw new DesignError("No valid bot property found")
      }
      
      if(properties.hasOwnProperty("to")) {
        session.variables.get(properties.to)
        .then(result => {
          if(result.hasOwnProperty("telegram")) {
            channel = agent.getChat(result.telegram)
            if(!channel) {throw new DesignError("couldn't find chat with " + JSON.stringify(result.telegram))}
            return session.variables.review(properties.text)
          } else {
            throw new DesignError("refered document " + properties.to + " has no telegram property")
          }
        })
        .then(reviewed_text => {
          return agent.send(channel, reviewed_text)
        })
        .then(res => {
          log.info(this.name, res.result.from.first_name + ' sent: "' + res.result.text + '" to chat ' + res.result.chat.first_name)
          return resolve(undefined)
        })
        .catch(error => {
          return reject(error)
        })
      } else {
        throw new DesignError("'to' property missing")
      }
    })
  }
}

/**
* represents a telegram API Bot. api key property allows it to make requests adressing the telegram bot.
* retrieves and stores chats the bot is currently in. 
*/
class Bot {
  constructor(config, app, doc) {
    Object.assign(this, config)
    
		this.app = app
    this.doc = doc
    
    if(!this.hasOwnProperty("chats")) {
      this.chats = {}
    }
    
    this.reconnect(config.settings)
  }
  
  reconnect(settings) {
    this.settings = settings
    this.settings.url = "https://api.telegram.org/bot" + settings.apikey
    this.settings.method = "GET"
    
    this.updateChats()
  }
  
  /**
  * request an telegram Bot API einen text an den chat zu senden
  * https://api.telegram.org/bot[BOT_API_KEY]/sendMessage?chat_id=[MY_CHANNEL_NAME]&amp;text=[MY_MESSAGE_TEXT]
  */
  send(chat_id, message) {
    return new Promise((resolve, reject) => {
      this.request("/sendMessage", {chat_id:chat_id, text:message})
      .then(result => {
        return resolve(result)
      })
      .catch(error => {
        log.error(this.name, error)
        return reject(error)
      })
    })
  }
  
  /**
	* make request to telegram api
  *
  * @param {string} subaddr - subaddress in the telegram api to define what type of request to make
	*/
	request(subaddr, data) {
    return new Promise((resolve, reject) => {
      //log.info(this.name, "request: ")
      //log.info(this.name, data)
      try {
        let options = {
          qs: data,
          url: this.settings.url + subaddr,
          method: this.settings.method
        }
        request(options, (err,response,body) => {
          if(err) { return reject(err) }
          if(typeof body === 'string') {
            try {
              //body = body.replace(/(\r\n|\n|\r)/gm, "")
              //log.info(this.name, body)
              body = JSON.parse(body)
            } catch(err) {
          		log.warn(this.name, 'error when parsing string to json.')
              log.warn(this.name, err)
            }
          }
          return resolve(body)
        })
      } catch(err) {
        log.error(this.name, err)
      }
    })
	}

	/**
	* handle response from request
	*/
	request_callback(err, response, body) {
    if(err) { log.error(this.name, new Error(err)); return; }
    if(response.hasOwnProperty('statusCode')) {
      if(response.statusCode == 404) {
  			log.error(this.name, new Error(e))
  		} else {
        log.info(this.name, "response status:", response.statusCode)
      }
    } else {
      log.warn(this.name, "invalid response (status code missing)")
    }
	}
  
  /**
  * get chat id based on channel first and last name or group chat title
  *
  * @param {string} [data.first_name] - first_name property of telegram user
  * @param {string} [data.last_name] - last_name property of telegram user
  * @param {string} [data.title] - title of group chat
  *
  * @returns {string} chat id if successfull. Else undefined
  */
  getChat(data) {
    if(data.hasOwnProperty("title")) {
      for(let chat in this.chats) {
        if(this.chats[chat].title == data.title) {
          return chat
        }
      }
    } else if(data.hasOwnProperty("first_name")) {
      for(let chat in this.chats) {
        if(this.chats[chat].first_name == data.first_name &amp;&amp; this.chats[chat].last_name == data.last_name) {
          return chat
        }
      }
    }
    return(undefined)
  }
  
  /**
  * pull update object for Bot https://api.telegram.org/bot[BOT_API_KEY]/getUpdates
  */
  updateChats() {
    this.request("/getUpdates", "")
    .then(result => {
      if(result.hasOwnProperty("result")) {
        for(let res of result.result) {
          if(res.hasOwnProperty("message")) {
            if(res.message.hasOwnProperty("chat")) {
              if(!this["chats"].hasOwnProperty(res.message.chat.id)) {
                log.info(this.name, "new chat acknoledged: ")
                log.info(this.name, res.message.chat)
                this["chats"][res.message.chat.id] = res.message.chat
                let updt = {}
                let addr = 'chats.' + res.message.chat.id
                updt[addr] = res.message.chat
                this.doc.set(updt)
              }
            }
          }
        }
      }
      
    })
    .catch(error => {
      log.error(this.name, error)
    })
  }
  
  command(input) {
		switch(input[0]) {
			case "update":
        this.updateChats()
				break
			default:
				log.warn(this.name, "doesn't understand " + input[0])
		}
  }
}

module.exports.Plaitool = Telegram
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-ableton.html">ableton</a></li><li><a href="module-control.html">control</a></li><li><a href="module-d-pro.html">d-pro</a></li><li><a href="module-device.html">device</a></li><li><a href="module-devices.html">devices</a></li><li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-logic.html">logic</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-phone.html">phone</a></li><li><a href="module-session.html">session</a></li><li><a href="module-sound.html">sound</a></li><li><a href="module-telegram.html">telegram</a></li><li><a href="module-tool.html">tool</a></li><li><a href="module-tradfri.html">tradfri</a></li><li><a href="module-twilio.html">twilio</a></li><li><a href="module-variables.html">variables</a></li></ul><h3>Classes</h3><ul><li><a href="CollectionAPI.html">CollectionAPI</a></li><li><a href="Data.html">Data</a></li><li><a href="module-ableton-Liveset.html">Liveset</a></li><li><a href="module-d-pro-Show.html">Show</a></li><li><a href="module-device-Device.html">Device</a></li><li><a href="module-device-Mididevice.html">Mididevice</a></li><li><a href="module-device-OSCdevice.html">OSCdevice</a></li><li><a href="module-device-Serialdevice.html">Serialdevice</a></li><li><a href="module-device-TCPdevice.html">TCPdevice</a></li><li><a href="module-device-UDPdevice.html">UDPdevice</a></li><li><a href="module-device-Webdevice.html">Webdevice</a></li><li><a href="module-errors-DesignError.html">DesignError</a></li><li><a href="module-game-Game.html">Game</a></li><li><a href="module-logic-Condition.html">Condition</a></li><li><a href="module-logic-Listener.html">Listener</a></li><li><a href="module-medley-Log.html">Log</a></li><li><a href="module-mongo-Collection.html">Collection</a></li><li><a href="module-mongo-Database.html">Database</a></li><li><a href="module-mongo-Document.html">Document</a></li><li><a href="module-ne-Collection.html">Collection</a></li><li><a href="module-ne-Database.html">Database</a></li><li><a href="module-ne-Document.html">Document</a></li><li><a href="module-phone-Phone.html">Phone</a></li><li><a href="module-session-Session.html">Session</a></li><li><a href="module-telegram-Bot.html">Bot</a></li><li><a href="module-tool-Collection.html">Collection</a></li><li><a href="module-tool-Item.html">Item</a></li><li><a href="module-tool-Tool.html">Tool</a></li><li><a href="module-twilio-Call.html">Call</a></li><li><a href="module-twilio-CallIn.html">CallIn</a></li><li><a href="module-twilio-SmsIn.html">SmsIn</a></li><li><a href="module-twilio-Switchboard.html">Switchboard</a></li><li><a href="module-variables-Variables.html">Variables</a></li></ul><h3>Global</h3><ul><li><a href="global.html#assignIntro">assignIntro</a></li><li><a href="global.html#assignStory">assignStory</a></li><li><a href="global.html#assignTaskC">assignTaskC</a></li><li><a href="global.html#attendance">attendance</a></li><li><a href="global.html#cancelPlayerSessions">cancelPlayerSessions</a></li><li><a href="global.html#cancelSessions">cancelSessions</a></li><li><a href="global.html#checkQueue">checkQueue</a></li><li><a href="global.html#cooperation">cooperation</a></li><li><a href="global.html#getLocationText">getLocationText</a></li><li><a href="global.html#getLoginLink">getLoginLink</a></li><li><a href="global.html#getPlace">getPlace</a></li><li><a href="global.html#getReader">getReader</a></li><li><a href="global.html#jobData">jobData</a></li><li><a href="global.html#left">left</a></li><li><a href="global.html#nextJob">nextJob</a></li><li><a href="global.html#since">since</a></li><li><a href="global.html#startValues">startValues</a></li><li><a href="global.html#timestamp">timestamp</a></li><li><a href="global.html#updateQueue">updateQueue</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Thu Dec 12 2019 19:18:46 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
